#include <stdio.h>
#include <assert.h>

#define MaxN 1000
#define Assert assert

char s[MaxN + 3];
int f[MaxN + 1][MaxN + 1];

int main(int argc, char** argv)
{
	int i, j, d, n, naj, kand, ok_;
	FILE *g = fopen(argc > 1 ? argv[1] : "brisanje.in", "rt");
	ok_ = fscanf(g, "%d\n", &n);
	Assert(ok_ == 1);
	Assert(1 <= n); Assert(n <= 1000);
	fgets(s, sizeof(s), g);
	fclose(g);

	for (i = 0; i < n; i++) { Assert('a' <= s[i]); Assert(s[i] <= 'z'); }
	Assert(s[n] == 0 || s[n] == '\n');
	for (i = 0; i <= n; i++) f[i][i] = 0;
	for (i = 0; i < n; i++) f[i][i + 1] = 1;
	for (d = 2; d <= n; d++) for (i = 0; i + d <= n; i++)
	{
		/* Kako najceneje pobrisati s[i:i+d]?
		   Ena monost je, da pobriemo s[i] samega zase in nato briemo s[i+1:i+d]. */
		naj = 1 + f[i + 1][i + d];
		for (j = i + 1; j < i + d; j++) if (s[j] == s[i])
		{
			/* Lahko pa poskuamo s[i:i+d] pobrisati tako, da tisto brisanje,
			   ki pobrie s[i], pobrie tudi s[j] in nobenega od vmesnih znakov.
			   Vmes moramo torej s[i+1:j] pobrisati v celoti, cena brisanja tega, kar
			   ostane --- to je s[i] + s[j:i+d] --- pa je enaka kot cena brisanja
			   s[j:i+d] samega po sebi, ker sta znaka s[i] in s[j] enaka in bomo lahko
			   s[i] pobrisali z istim brisanjem, ki pobrie tudi s[j]. */
			kand = f[i+1][j] + f[j][i + d];
			if (kand < naj) naj = kand;
		}
		f[i][i + d] = naj;
		if (0) printf("f[%d:%d] = %d\n", i, i + d, naj);
	}

	g = fopen(argc > 2 ? argv[2] : "brisanje.out", "wt");
	fprintf(g, "%d\n", f[0][n]); fclose(g); return 0;
}